/*
 *  MyFirstJNILib.c
 *  MyLeopardJNIProject
 *
 *  Created by Yuanying on 07/12/12.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include <MyFirstJNILib.h>
#include <AddressBook/AddressBook.h>

/*
 * Class:     MyFirstJNIProject
 * Method:    getMyFullName
 * Signature: ()Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_MyLeopardJNIProject_getMyFullName
  (JNIEnv *env, jobject obj) {
	ABAddressBookRef book = ABGetSharedAddressBook();
	ABPersonRef me = ABGetMe(book);
	
	
	// Get the first and last name.  For more properties, see "Person specific properties"
	// in ABGlobalsC.h
	CFMutableArrayRef names = CFArrayCreateMutable(kCFAllocatorDefault, 0, &kCFTypeArrayCallBacks);
	CFStringRef firstName = ABRecordCopyValue(me, kABFirstNameProperty);
	CFStringRef lastName = ABRecordCopyValue(me, kABLastNameProperty);
	
	if (firstName && CFStringGetLength(firstName) > 0) {
		CFArrayAppendValue(names, (const void *)firstName);
	}
	if (lastName && CFStringGetLength(lastName) > 0) {
		CFArrayAppendValue(names, (const void *)lastName);
	}
	
	// merge the first and last names into one CFString
	// An empty string (size 0) are still safely created by the JNI; no check is necessary
	CFStringRef firstAndLastName = CFStringCreateByCombiningStrings(kCFAllocatorDefault, names, CFSTR(" "));
	CFIndex strLen = CFStringGetLength(firstAndLastName);
	UniChar uniStr[strLen];
	CFRange strRange;
	strRange.location = 0;
	strRange.length = strLen;
	CFStringGetCharacters(firstAndLastName, strRange, uniStr);
	
	// return a jstring from the full name's bytes
	jstring javaName = (*env)->NewString(env, (jchar *)uniStr, (jsize)strLen);
		
	CFRelease(names);
	CFRelease(firstAndLastName);
	
	return javaName;
}